//+------------------------------------------------------------------+
//|                                                  cmf 4 color mtf |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    1
#property indicator_color1     Red
#property indicator_width1     2
#property indicator_level3     0
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern string TimeFrame = "Current time frame";
extern int fastMaPeriod  = 3;
extern int fastMaMode    = MODE_LWMA;
extern int slowMaPeriod  = 10;
extern int slowMaMode    = MODE_LWMA;

//
//
//
//
//

double cmf[];
double ad[];
double co[];
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,co); 
   SetIndexBuffer(1,cmf); 
   SetIndexBuffer(2,ad); 


      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
                       
   IndicatorShortName(timeFrameToString(timeFrame)+" Chalkin Oscillator  ("+fastMaPeriod+","+slowMaPeriod+")"); 
return(0);
}

//
//
//
//
//

int deinit() {   return(0);  }

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { co[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for (i=limit;i>=0;i--)
      {
          if((High[i]-Low[i]) != 0 && Volume[i] !=0)
               cmf[i] = (Volume[i]*(Close[i]-Open[i])/(High[i]-Low[i]))/Volume[i];
          else cmf[i] = 0;
               ad[i]  = ad[i+1]+cmf[i];
     }
     for (i=limit;i>=0;i--) co[i] = iMAOnArray(ad,0,fastMaPeriod,0,fastMaMode,i)-iMAOnArray(ad,0,slowMaPeriod,0,slowMaMode,i);        
     return(0);
   }
   
   //
   //
   //
   //
   //
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         co[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",fastMaPeriod,fastMaMode,slowMaPeriod,slowMaMode,0,y);
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}   